
<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>nl2declare &#8212; NL2Declare  documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/alabaster.css" />
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/_sphinx_javascript_frameworks_compat.js"></script>
    <script src="../_static/doctools.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
   
  <link rel="stylesheet" href="../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for nl2declare</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">csv</span>
<span class="kn">import</span> <span class="nn">xml.etree.ElementTree</span> <span class="k">as</span> <span class="nn">ET</span>
<span class="kn">from</span> <span class="nn">nl2declare.lingproc.text_parser</span> <span class="kn">import</span> <span class="n">TextParser</span>
<span class="kn">from</span> <span class="nn">nl2declare.lingproc.declare_constructor</span> <span class="kn">import</span> <span class="n">DeclareConstructor</span>
<span class="kn">from</span> <span class="nn">nl2declare.actmatching.activity_matching_word2vec</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.declare_model</span> <span class="kn">import</span> <span class="n">DeclareModel</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.constraint_type</span> <span class="kn">import</span> <span class="n">ConstraintType</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.action</span> <span class="kn">import</span> <span class="n">Action</span>
<span class="kn">from</span> <span class="nn">nl2declare.application.d4py</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">from</span> <span class="nn">io</span> <span class="kn">import</span> <span class="n">StringIO</span>
<span class="kn">import</span> <span class="nn">tempfile</span>
<span class="kn">import</span> <span class="nn">pathlib</span>

<span class="n">parser</span> <span class="o">=</span> <span class="n">TextParser</span><span class="p">()</span>

<div class="viewcode-block" id="run_on_csv"><a class="viewcode-back" href="../nl2declare.html#nl2declare.run_on_csv">[docs]</a><span class="k">def</span> <span class="nf">run_on_csv</span><span class="p">(</span><span class="n">csv_as_string</span><span class="p">,</span> <span class="n">target_activity_event_log</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    run_on_csv: Extracts declare constraints out of a CSV file.</span>

<span class="sd">    This function takes a CSV-formatted string (`csv_as_string`) out of the column &quot;Used Constraint&quot; and an</span>
<span class="sd">    event log. If the column does not exist, empty lists are returned. Else  (nodes,edges). If the event log has a column &quot;Concept:Name&quot; , the activites </span>
<span class="sd">    from the constraints are matched with those labels. As third element also a .decl file of the constraints is returned.</span>

<span class="sd">    Parameters:</span>
<span class="sd">        - csv_as_string (str): A CSV-formatted string containing data to be processed.</span>
<span class="sd">        - target_activity_event_log (str): The target_activity_event_log log for processing or an empty string.</span>

<span class="sd">    Returns:</span>
<span class="sd">        - Nodes: All actions from the found constraints as nodes for a declare graph</span>
<span class="sd">        - Edges: All relations from the found constraints as edges for a declare graph</span>
<span class="sd">        - .decl file: The found declare constraints as d4py file (.decl). This file can be used for further examinations using d4py.</span>

<span class="sd">    Notes:</span>
<span class="sd">        - If the &quot;Used constraint&quot; column is not present, an empty tuple is returned.</span>
<span class="sd">        - The target_activity_event_log can be empty</span>
<span class="sd">        - If the target_activity_event_log is not empty, all labels that should be matched need to be i a column called &quot;Concept:Name&quot;</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1">#Create a file-like object from the string</span>
    <span class="n">csv_file</span> <span class="o">=</span> <span class="n">StringIO</span><span class="p">(</span><span class="n">csv_as_string</span><span class="p">)</span>
    <span class="c1"># Read the CSV data</span>
    <span class="n">reader</span> <span class="o">=</span> <span class="n">csv</span><span class="o">.</span><span class="n">DictReader</span><span class="p">(</span><span class="n">csv_file</span><span class="p">)</span>

    <span class="c1">#if we have a &quot;used constraint&quot; column we use all data from that column, else we return empty</span>
    <span class="k">if</span> <span class="s1">&#39;Used constraint&#39;</span> <span class="ow">in</span> <span class="n">reader</span><span class="o">.</span><span class="n">fieldnames</span><span class="p">:</span>
        <span class="n">text_content</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span><span class="o">.</span><span class="n">join</span><span class="p">([</span><span class="n">row</span><span class="p">[</span><span class="s1">&#39;Used constraint&#39;</span><span class="p">]</span> <span class="k">for</span> <span class="n">row</span> <span class="ow">in</span> <span class="n">reader</span><span class="p">])</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="p">([],[],[])</span> <span class="c1">#empty if no column called &quot;Used constraint&quot;</span>

    <span class="k">return</span> <span class="n">run_on_text</span><span class="p">(</span><span class="n">text_content</span><span class="p">,</span> <span class="n">target_activity_event_log</span><span class="p">)</span></div>



<div class="viewcode-block" id="run_on_text"><a class="viewcode-back" href="../nl2declare.html#nl2declare.run_on_text">[docs]</a><span class="k">def</span> <span class="nf">run_on_text</span><span class="p">(</span><span class="n">textstring</span><span class="p">,</span> <span class="n">target_activity_event_log</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    run_on_text: Extracts declare constraints out of a text.</span>

<span class="sd">    This function takes a text string (`textstring`) and an event log. If the event log has a column &quot;Concept:Name&quot; , the activites </span>
<span class="sd">    from the constraints are matched with those labels. The found declare constraints from the text are returned in a graph format. </span>
<span class="sd">    As third element also a .decl file of the constraints is returned.</span>

<span class="sd">    Parameters:</span>
<span class="sd">        - textstring (str): A text string containing sentences to be processed.</span>
<span class="sd">        - target_activity_event_log (str): The target_activity_event_log log for processing or an empty string.</span>

<span class="sd">    Returns:</span>
<span class="sd">        - Nodes: All actions from the found constraints as nodes for a declare graph</span>
<span class="sd">        - Edges: All relations from the found constraints as edges for a declare graph</span>
<span class="sd">        - .decl file: The found declare constraints as d4py file (.decl). This file can be used for further examinations using d4py.</span>

<span class="sd">    Notes:</span>
<span class="sd">        - The target_activity_event_log can be empty</span>
<span class="sd">        - If the target_activity_event_log is not empty, all labels that should be matched need to be i a column called &quot;Concept:Name&quot;</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">all_constraints_set</span> <span class="o">=</span> <span class="n">create_constraint_set_from_text</span><span class="p">(</span><span class="n">textstring</span><span class="p">,</span> <span class="n">target_activity_event_log</span><span class="p">)</span>

    <span class="c1"># Iterate all unary constraints and collect their nodes</span>
    <span class="n">unary_nodes</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">init_nodes</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">end_nodes</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">con</span> <span class="ow">in</span> <span class="n">all_constraints_set</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">con</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">INIT</span><span class="p">:</span>
            <span class="n">action_str</span> <span class="o">=</span> <span class="n">con</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span>
            <span class="k">if</span> <span class="n">action_str</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">unary_nodes</span><span class="p">:</span>
                <span class="n">unary_nodes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">action_str</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">action_str</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">init_nodes</span><span class="p">:</span>
                <span class="n">init_nodes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">action_str</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">con</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">END</span><span class="p">:</span>
            <span class="n">action_str</span> <span class="o">=</span> <span class="n">con</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span>
            <span class="k">if</span> <span class="n">action_str</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">unary_nodes</span><span class="p">:</span>
                <span class="n">unary_nodes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">action_str</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">action_str</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">end_nodes</span><span class="p">:</span>
                <span class="n">end_nodes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">action_str</span><span class="p">)</span>
    
    <span class="c1"># Create lookup dictionary for the nodes with unary constraints with their new action string</span>
    <span class="n">unary_nodes_name_lookup</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">for</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">unary_nodes</span><span class="p">:</span>
        <span class="n">is_init</span> <span class="o">=</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">init_nodes</span>
        <span class="n">is_end</span> <span class="o">=</span> <span class="n">node</span> <span class="ow">in</span> <span class="n">end_nodes</span>
        <span class="k">if</span> <span class="n">is_init</span> <span class="ow">and</span> <span class="n">is_end</span><span class="p">:</span>
            <span class="n">unary_nodes_name_lookup</span><span class="p">[</span><span class="n">node</span><span class="p">]</span> <span class="o">=</span> <span class="s2">&quot;Start and End:</span><span class="se">\n</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="n">node</span>
        <span class="k">elif</span> <span class="n">is_init</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">is_end</span><span class="p">:</span>
            <span class="n">unary_nodes_name_lookup</span><span class="p">[</span><span class="n">node</span><span class="p">]</span> <span class="o">=</span> <span class="s2">&quot;Start:</span><span class="se">\n</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="n">node</span>
        <span class="k">elif</span> <span class="ow">not</span> <span class="n">is_init</span> <span class="ow">and</span> <span class="n">is_end</span><span class="p">:</span>
            <span class="n">unary_nodes_name_lookup</span><span class="p">[</span><span class="n">node</span><span class="p">]</span> <span class="o">=</span> <span class="s2">&quot;End:</span><span class="se">\n</span><span class="s2">&quot;</span> <span class="o">+</span> <span class="n">node</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="s2">&quot;Something went wrong during unary constraint extraction&quot;</span><span class="p">)</span>

    <span class="c1"># Iterate all constraints and collect the nodes and edges of the graph:</span>
    <span class="n">nodes</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">edges</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">con</span> <span class="ow">in</span> <span class="n">all_constraints_set</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">con</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">INIT</span> <span class="ow">or</span> <span class="n">con</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">END</span><span class="p">:</span>
            <span class="n">node</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;name&quot;</span><span class="p">:</span> <span class="n">unary_nodes_name_lookup</span><span class="p">[</span><span class="n">con</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()]}</span>
            <span class="k">if</span> <span class="n">node</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">nodes</span><span class="p">:</span>
                <span class="n">nodes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">node</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">action_a_str</span> <span class="o">=</span> <span class="n">con</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span>
            <span class="n">action_a_str</span> <span class="o">=</span> <span class="n">unary_nodes_name_lookup</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">action_a_str</span><span class="p">,</span> <span class="n">action_a_str</span><span class="p">)</span> <span class="c1"># If the action has an unary constraint update the action string</span>
            <span class="n">action_b_str</span> <span class="o">=</span> <span class="n">con</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span>
            <span class="n">action_b_str</span> <span class="o">=</span> <span class="n">unary_nodes_name_lookup</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">action_b_str</span><span class="p">,</span> <span class="n">action_b_str</span><span class="p">)</span> <span class="c1"># If the action has an unary constraint update the action string</span>
            <span class="n">node_a</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;name&quot;</span><span class="p">:</span> <span class="n">action_a_str</span><span class="p">}</span>
            <span class="n">node_b</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;name&quot;</span><span class="p">:</span> <span class="n">action_b_str</span><span class="p">}</span>
            <span class="k">if</span> <span class="n">node_a</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">nodes</span><span class="p">:</span>
                <span class="n">nodes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">node_a</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">node_b</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">nodes</span><span class="p">:</span>
                <span class="n">nodes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">node_b</span><span class="p">)</span>
            <span class="n">constraint_str</span> <span class="o">=</span> <span class="s2">&quot;!&quot;</span> <span class="o">+</span> <span class="n">con</span><span class="o">.</span><span class="n">type</span><span class="o">.</span><span class="n">name</span> <span class="k">if</span> <span class="n">con</span><span class="o">.</span><span class="n">is_negative</span> <span class="k">else</span> <span class="n">con</span><span class="o">.</span><span class="n">type</span><span class="o">.</span><span class="n">name</span>
            <span class="n">edge</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;source&quot;</span><span class="p">:</span> <span class="n">action_a_str</span><span class="p">,</span> <span class="s2">&quot;target&quot;</span><span class="p">:</span> <span class="n">action_b_str</span><span class="p">,</span> <span class="s2">&quot;label&quot;</span><span class="p">:</span> <span class="p">{</span><span class="s2">&quot;show&quot;</span><span class="p">:</span> <span class="kc">True</span><span class="p">,</span> <span class="s2">&quot;formatter&quot;</span><span class="p">:</span> <span class="n">constraint_str</span><span class="p">}}</span>
            <span class="n">edges</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">edge</span><span class="p">)</span>

    <span class="n">declare_export</span> <span class="o">=</span> <span class="n">create_d4py_declaremodel</span><span class="p">(</span><span class="n">all_constraints_set</span><span class="p">)</span>

    <span class="k">return</span> <span class="p">(</span><span class="n">nodes</span><span class="p">,</span><span class="n">edges</span><span class="p">,</span><span class="n">declare_export</span><span class="p">)</span></div>

<div class="viewcode-block" id="create_constraint_set_from_text"><a class="viewcode-back" href="../nl2declare.html#nl2declare.create_constraint_set_from_text">[docs]</a><span class="k">def</span> <span class="nf">create_constraint_set_from_text</span><span class="p">(</span><span class="n">textstring</span><span class="p">,</span> <span class="n">event_log</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Create_constraint_set_from_text: Extracts declare constraints out of a text.</span>

<span class="sd">    This function takes a text string (`textstring`) and an event log. If the event log has a column &quot;Concept:Name&quot; , the activites </span>
<span class="sd">    from the constraints are matched with those labels.The found declare constraints are returned in a set.</span>

<span class="sd">    Parameters:</span>
<span class="sd">        - textstring (str): A text string containing sentences to be processed.</span>
<span class="sd">        - event_log (str): The target_activity_event_log log for processing or an empty string.</span>

<span class="sd">    Returns:</span>
<span class="sd">        - Set of found declare_constraints</span>

<span class="sd">    Notes:</span>
<span class="sd">        - The target_activity_event_log can be empty</span>
<span class="sd">        - If the target_activity_event_log is not empty, all labels that should be matched need to be i a column called &quot;Concept:Name&quot;</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">declare_constructor</span> <span class="o">=</span> <span class="n">DeclareConstructor</span><span class="p">()</span>
    <span class="n">all_constraints</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">all_actions</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span>
    <span class="n">MATCHING_THRESHOLD</span> <span class="o">=</span> <span class="mf">0.5</span>

    <span class="c1"># Split the text into sentences and remove empty strings </span>
    <span class="n">sentences</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;[.!?]&#39;</span><span class="p">,</span> <span class="n">textstring</span><span class="p">)</span>
    <span class="n">sentences</span> <span class="o">=</span> <span class="p">[</span><span class="n">sentence</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span> <span class="k">for</span> <span class="n">sentence</span> <span class="ow">in</span> <span class="n">sentences</span> <span class="k">if</span> <span class="n">sentence</span><span class="o">.</span><span class="n">strip</span><span class="p">()]</span>

    <span class="c1"># Extract constraints from all sentences</span>
    <span class="k">for</span> <span class="n">sentence</span> <span class="ow">in</span> <span class="n">sentences</span><span class="p">:</span>
        <span class="n">text_model_for_sentence</span> <span class="o">=</span> <span class="n">parser</span><span class="o">.</span><span class="n">parse_constraint_string</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">act</span> <span class="ow">in</span> <span class="n">text_model_for_sentence</span><span class="o">.</span><span class="n">actions</span><span class="p">:</span>
            <span class="n">all_actions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">act</span><span class="o">.</span><span class="n">action_str</span><span class="p">())</span>
        <span class="n">declare_model_for_sentence</span> <span class="o">=</span> <span class="n">declare_constructor</span><span class="o">.</span><span class="n">convert_to_declare_model</span><span class="p">(</span><span class="n">text_model_for_sentence</span><span class="p">)</span>
        <span class="n">declare_model_for_sentence</span><span class="o">.</span><span class="n">sentence_model</span> <span class="o">=</span> <span class="n">text_model_for_sentence</span>
        <span class="c1"># Collect the extracted constraints in all_constraints</span>
        <span class="n">all_constraints</span><span class="o">.</span><span class="n">extend</span><span class="p">(</span><span class="n">declare_model_for_sentence</span><span class="o">.</span><span class="n">constraints</span><span class="p">)</span>

    <span class="n">all_actions</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">all_actions</span><span class="p">)</span>

    <span class="c1">#perform activity matching</span>
        
    <span class="k">if</span> <span class="n">event_log</span> <span class="o">!=</span> <span class="s2">&quot;&quot;</span><span class="p">:</span> <span class="c1">#if we get an xes file</span>
        <span class="n">target_activity_list</span> <span class="o">=</span> <span class="n">get_activities_from_event_log</span><span class="p">(</span><span class="n">event_log</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span><span class="c1">#if we do not get an xes file</span>
        <span class="n">target_activity_list</span> <span class="o">=</span> <span class="p">[]</span>
    
    <span class="c1">#first pairwise activity matching</span>
    <span class="k">for</span> <span class="n">const</span> <span class="ow">in</span> <span class="n">all_constraints</span><span class="p">:</span>
            <span class="n">new_act_a</span> <span class="o">=</span> <span class="kc">None</span>
            <span class="n">new_act_b</span> <span class="o">=</span> <span class="kc">None</span>
            <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">to_check_list</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">all_actions</span> <span class="k">if</span> <span class="n">x</span> <span class="o">!=</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()]</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">to_check_list</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">all_actions</span> <span class="k">if</span> <span class="n">x</span> <span class="o">!=</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="ow">and</span> <span class="n">x</span><span class="o">!=</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">()]</span>
                <span class="k">if</span><span class="p">(</span><span class="n">to_check_list</span> <span class="o">!=</span> <span class="p">[]):</span>
                    <span class="n">most_similar_action</span><span class="p">,</span> <span class="n">similarity_value</span> <span class="o">=</span> <span class="n">get_most_similar_activity_without_common_words</span><span class="p">(</span><span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">(),</span> <span class="n">to_check_list</span><span class="p">)</span>
                    <span class="k">if</span> <span class="n">similarity_value</span> <span class="o">&gt;=</span> <span class="n">MATCHING_THRESHOLD</span><span class="p">:</span>
                        <span class="n">new_act_a</span> <span class="o">=</span> <span class="n">Action</span><span class="p">(</span><span class="n">most_similar_action</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
                        <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="ow">in</span> <span class="n">all_actions</span><span class="p">:</span>
                            <span class="n">all_actions</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">())</span>
            <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">to_check_list</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">all_actions</span> <span class="k">if</span> <span class="n">x</span> <span class="o">!=</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">()]</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">to_check_list</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">all_actions</span> <span class="k">if</span> <span class="n">x</span> <span class="o">!=</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="ow">and</span> <span class="n">x</span><span class="o">!=</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()]</span>
                <span class="k">if</span><span class="p">(</span><span class="n">to_check_list</span> <span class="o">!=</span> <span class="p">[]):</span>
                    <span class="n">most_similar_action</span><span class="p">,</span> <span class="n">similarity_value</span> <span class="o">=</span> <span class="n">get_most_similar_activity_without_common_words</span><span class="p">(</span><span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">(),</span> <span class="n">to_check_list</span><span class="p">)</span>
                    <span class="k">if</span> <span class="n">similarity_value</span> <span class="o">&gt;=</span> <span class="n">MATCHING_THRESHOLD</span><span class="p">:</span>
                        <span class="n">new_act_b</span> <span class="o">=</span> <span class="n">Action</span><span class="p">(</span><span class="n">most_similar_action</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
                        <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="ow">in</span> <span class="n">all_actions</span><span class="p">:</span>
                            <span class="n">all_actions</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">())</span>
            <span class="k">if</span> <span class="n">new_act_a</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span> 
                <span class="n">const</span><span class="o">.</span><span class="n">action_a</span> <span class="o">=</span> <span class="n">new_act_a</span>
            <span class="k">if</span> <span class="n">new_act_b</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span> 
                <span class="n">const</span><span class="o">.</span><span class="n">action_b</span> <span class="o">=</span> <span class="n">new_act_b</span>

    <span class="n">all_constraints_set</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">all_constraints</span><span class="p">)</span>

    <span class="c1">#then, if available, match reference activities from event log</span>
    <span class="k">if</span> <span class="n">target_activity_list</span> <span class="o">!=</span> <span class="p">[]:</span> <span class="c1">#we HAVE activities from reference event log</span>
        <span class="c1">#check for all constraints in all_constraints if we can match one of its actions with one of the reference labels -&gt; find the best and check if similarity &gt; 0.8</span>
        <span class="k">for</span> <span class="n">const</span> <span class="ow">in</span> <span class="n">all_constraints_set</span><span class="p">:</span>
            <span class="n">new_act_a</span> <span class="o">=</span> <span class="kc">None</span>
            <span class="n">new_act_b</span> <span class="o">=</span> <span class="kc">None</span>
            <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">most_similar_action</span><span class="p">,</span> <span class="n">similarity_value</span> <span class="o">=</span> <span class="n">get_most_similar_activity_without_common_words</span><span class="p">(</span><span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">(),</span> <span class="n">target_activity_list</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">similarity_value</span> <span class="o">&gt;=</span> <span class="n">MATCHING_THRESHOLD</span><span class="p">:</span>
                    <span class="n">new_act_a</span> <span class="o">=</span> <span class="n">Action</span><span class="p">(</span><span class="n">most_similar_action</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">most_similar_action</span><span class="p">,</span> <span class="n">similarity_value</span> <span class="o">=</span> <span class="n">get_most_similar_activity_without_common_words</span><span class="p">(</span><span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">(),</span> <span class="n">target_activity_list</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">similarity_value</span> <span class="o">&gt;=</span> <span class="n">MATCHING_THRESHOLD</span><span class="p">:</span>
                    <span class="n">new_act_b</span> <span class="o">=</span> <span class="n">Action</span><span class="p">(</span><span class="n">most_similar_action</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">new_act_a</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span> 
                <span class="n">const</span><span class="o">.</span><span class="n">action_a</span> <span class="o">=</span> <span class="n">new_act_a</span>
            <span class="k">if</span> <span class="n">new_act_b</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span> 
                <span class="n">const</span><span class="o">.</span><span class="n">action_b</span> <span class="o">=</span> <span class="n">new_act_b</span>

    <span class="k">return</span> <span class="n">all_constraints_set</span></div>

<div class="viewcode-block" id="conformance_checking"><a class="viewcode-back" href="../nl2declare.html#nl2declare.conformance_checking">[docs]</a><span class="k">def</span> <span class="nf">conformance_checking</span><span class="p">(</span><span class="n">textstring</span><span class="p">:</span><span class="nb">str</span><span class="p">,</span> <span class="n">xes_log</span><span class="p">:</span><span class="nb">str</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Conformance_checking:</span>

<span class="sd">    Parameters:</span>
<span class="sd">        - textstring (str): A text string containing sentences to be processed.</span>
<span class="sd">        - event_log (str): ...</span>

<span class="sd">    Returns:</span>
<span class="sd">    </span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">all_constraints_set</span> <span class="o">=</span> <span class="n">create_constraint_set_from_text</span><span class="p">(</span><span class="n">textstring</span><span class="p">,</span> <span class="n">xes_log</span><span class="p">)</span>
    <span class="n">reference_model</span> <span class="o">=</span> <span class="n">create_d4py_declaremodel</span><span class="p">(</span><span class="n">all_constraints_set</span><span class="p">)</span>
    <span class="n">declare_model</span> <span class="o">=</span> <span class="n">DeclareModel</span><span class="p">()</span><span class="o">.</span><span class="n">parse_from_string</span><span class="p">(</span><span class="n">reference_model</span><span class="p">,</span><span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)</span>
    <span class="n">model_constraints</span> <span class="o">=</span> <span class="n">declare_model</span><span class="o">.</span><span class="n">get_decl_model_constraints</span><span class="p">()</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;decl_const&quot;</span><span class="p">,</span> <span class="n">model_constraints</span><span class="p">)</span>

    <span class="k">with</span> <span class="n">tempfile</span><span class="o">.</span><span class="n">NamedTemporaryFile</span><span class="p">(</span><span class="n">delete</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span> <span class="k">as</span> <span class="n">file</span><span class="p">:</span>
        <span class="n">file</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="nb">str</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="n">xes_log</span><span class="p">))</span>
        <span class="n">file_path</span> <span class="o">=</span> <span class="n">file</span><span class="o">.</span><span class="n">name</span>

    <span class="n">event_log</span> <span class="o">=</span> <span class="n">D4PyEventLog</span><span class="p">(</span><span class="n">case_name</span><span class="o">=</span><span class="s2">&quot;case:concept:name&quot;</span><span class="p">)</span>
    <span class="n">event_log</span><span class="o">.</span><span class="n">parse_xes_log</span><span class="p">(</span><span class="n">file_path</span><span class="p">)</span> 
    <span class="n">discovery</span> <span class="o">=</span> <span class="n">DeclareMiner</span><span class="p">(</span><span class="n">log</span><span class="o">=</span><span class="n">event_log</span><span class="p">,</span> <span class="n">consider_vacuity</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">min_support</span><span class="o">=</span><span class="mf">0.66</span><span class="p">,</span> <span class="n">itemsets_support</span><span class="o">=</span><span class="mf">0.66</span><span class="p">,</span> <span class="n">max_declare_cardinality</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>
    <span class="n">discovered_model</span><span class="p">:</span> <span class="n">DeclareModel</span> <span class="o">=</span> <span class="n">discovery</span><span class="o">.</span><span class="n">run</span><span class="p">()</span>
    <span class="n">log_constraints</span> <span class="o">=</span> <span class="n">discovered_model</span><span class="o">.</span><span class="n">get_decl_model_constraints</span><span class="p">()</span>
    <span class="c1">#print(&quot;log_const&quot;, log_constraints)</span>

    <span class="n">result_csv</span> <span class="o">=</span> <span class="n">get_conformance_metrics</span><span class="p">(</span><span class="n">declare_model</span><span class="p">,</span> <span class="n">event_log</span><span class="p">)</span>
    <span class="n">precision</span> <span class="o">=</span> <span class="n">compute_precision</span><span class="p">(</span><span class="n">model_constraints</span><span class="p">,</span> <span class="n">log_constraints</span><span class="p">)</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">precision</span><span class="p">)</span>
    <span class="n">result_csv</span> <span class="o">=</span> <span class="n">result_csv</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2"> precision:;&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">precision</span><span class="p">)</span>

    <span class="n">pathlib</span><span class="o">.</span><span class="n">Path</span><span class="p">(</span><span class="n">file_path</span><span class="p">)</span><span class="o">.</span><span class="n">unlink</span><span class="p">(</span><span class="n">missing_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">result_csv</span></div>

<div class="viewcode-block" id="get_activities_from_event_log"><a class="viewcode-back" href="../nl2declare.html#nl2declare.get_activities_from_event_log">[docs]</a><span class="k">def</span> <span class="nf">get_activities_from_event_log</span><span class="p">(</span><span class="n">xes_file</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    get_activities_from_event_log: Produces a unique list of activities extracted from an event log.</span>

<span class="sd">    Parameters:</span>
<span class="sd">    - xes_file (str): A xes file as string.</span>

<span class="sd">    Returns:</span>
<span class="sd">    - list of unique activities from the column &quot;concept:name&quot;</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">activities</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span> <span class="c1">#use set so the ativities are unique</span>
    <span class="c1"># Parse file </span>
    <span class="n">root</span> <span class="o">=</span> <span class="n">ET</span><span class="o">.</span><span class="n">fromstring</span><span class="p">(</span><span class="n">xes_file</span><span class="p">)</span>
    <span class="c1"># Define the namespace used in XES files</span>
    <span class="n">ns</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;xes&#39;</span><span class="p">:</span> <span class="s1">&#39;http://www.xes-standard.org/&#39;</span><span class="p">}</span>

    <span class="c1"># Find all activities</span>
    <span class="k">for</span> <span class="n">trace</span> <span class="ow">in</span> <span class="n">root</span><span class="o">.</span><span class="n">findall</span><span class="p">(</span><span class="s2">&quot;.//xes:trace&quot;</span><span class="p">,</span> <span class="n">namespaces</span><span class="o">=</span><span class="n">ns</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">event</span> <span class="ow">in</span> <span class="n">trace</span><span class="o">.</span><span class="n">findall</span><span class="p">(</span><span class="s2">&quot;.//xes:event&quot;</span><span class="p">,</span> <span class="n">namespaces</span><span class="o">=</span><span class="n">ns</span><span class="p">):</span>
            <span class="n">act</span> <span class="o">=</span> <span class="n">event</span><span class="o">.</span><span class="n">find</span><span class="p">(</span><span class="s2">&quot;.//xes:string[@key=&#39;concept:name&#39;]&quot;</span><span class="p">,</span> <span class="n">namespaces</span><span class="o">=</span><span class="n">ns</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">act</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">activity</span> <span class="o">=</span> <span class="n">act</span><span class="o">.</span><span class="n">attrib</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;value&#39;</span><span class="p">)</span>
                <span class="n">activities</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">activity</span><span class="p">)</span>

    <span class="k">return</span> <span class="nb">list</span><span class="p">(</span><span class="n">activities</span><span class="p">)</span> <span class="c1">#return as list</span></div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../index.html">NL2Declare</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../modules.html">nl2declare</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../index.html">Documentation overview</a><ul>
  <li><a href="index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2024, Pia Halkour, Marc Ludevid Wulf, Julian Kofferath.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 5.0.2</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
    </div>

    

    
  </body>
</html>